import { App, DbItem, DbPlugin, DbPluginConfig, HandleRequest, Jovo, PersistableSessionData, PersistableUserData } from '@jovotech/framework';
import { DynamoDBClient, DynamoDBClientConfig } from '@aws-sdk/client-dynamodb';
export interface DynamoDbConfig extends DbPluginConfig {
    table: {
        name: string;
        createTableOnInit?: boolean;
        primaryKeyColumn?: string;
        readCapacityUnits?: number;
        writeCapacityUnits?: number;
    };
    libraryConfig?: {
        dynamoDbClient?: DynamoDBClientConfig;
    };
}
export interface DynamoDbItem {
    id: string;
    user?: PersistableUserData;
    session?: PersistableSessionData;
    createdAt?: string;
    updatedAt?: string;
}
export declare class DynamoDb extends DbPlugin<DynamoDbConfig> {
    client: DynamoDBClient;
    getDefaultConfig(): DynamoDbConfig;
    constructor(config: DynamoDbConfig);
    initialize(): Promise<void>;
    install(parent: App): Promise<void>;
    createTable: () => Promise<void>;
    getDbItem: (primaryKey: string) => Promise<DbItem>;
    loadData: (handleRequest: HandleRequest, jovo: Jovo) => Promise<void>;
    saveData: (handleRequest: HandleRequest, jovo: Jovo) => Promise<void>;
    checkRequirements: () => void | Error;
}
